package it.eng.spago.cms.exec.operations;

import it.eng.spago.base.SourceBean;
import it.eng.spago.cms.exceptions.BuildOperationException;
import it.eng.spago.cms.util.constants.ModuleConstants;
import it.eng.spago.cms.util.constants.OperationsConstants;
import it.eng.spago.tracing.TracerSingleton;

/*
    <OPERATION name="">
  	    <SEARCHOPERATION query="?" language="(xpath/sql)" />
  	</OPERATION>
*/

public class SearchOperation implements Operation {

	private SourceBean operationDescriptor = null;
	
	public SearchOperation() throws BuildOperationException {	
		try {
			operationDescriptor = new SourceBean(OperationsConstants.NAME_SEARCH_OPERATION);
			operationDescriptor.setAttribute(OperationsConstants.QUERY_ATTRIBUTE, "");
			operationDescriptor.setAttribute(OperationsConstants.LANGUAGE_ATTRIBUTE, "xpath");
		} catch (Exception e) {
			TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                "SearchOperation::<init>(): Error during the creation of the search operation" +
                                "SourceBean");
			throw new BuildOperationException("SearchOperation::<init>(): Error during the creation of the " +
					                          "search operation SourceBean", e);
		}
	}
	
	public SearchOperation(SourceBean descriptor){	
		operationDescriptor = descriptor;
	}
	
	public SourceBean getOperationDescriptor() {
		return operationDescriptor;
	}

	public boolean isComplete() {
		return true;
	}

	
	public void setQuery(String query) throws BuildOperationException {
		try {
			operationDescriptor.updAttribute(OperationsConstants.QUERY_ATTRIBUTE, query);
		} catch (Exception e) {
			TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                "SearchOperation::setQuery: Error during the query setting");
            throw new BuildOperationException("SearchOperation::setQuery: Error during the path setting", e);
		}
	}
	
	public void setLanguage(String language) throws BuildOperationException {
		try {
			operationDescriptor.updAttribute(OperationsConstants.LANGUAGE_ATTRIBUTE, language);
		} catch (Exception e) {
			TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                "SearchOperation::setLanguage: Error during the language setting");
            throw new BuildOperationException("SearchOperation::setLanguage: Error during the language setting", e);
		}
	}
	
}
