package it.eng.spago.cms.exec.results;

import java.io.InputStream;
import java.util.List;
import java.util.Vector;

import it.eng.spago.cms.exec.entities.ElementProperty;
import it.eng.spago.cms.util.constants.OperationsConstants;
import it.eng.spago.cms.util.constants.PropertiesConstants;
import it.eng.spago.base.SourceBean;

public class ElementDescriptor {

	private SourceBean descriptor;
	
	public ElementDescriptor(SourceBean desc) {
		descriptor = desc;
	}
	
	public SourceBean getDescriptor() {
		return descriptor;
	}
	
	public ElementProperty[] getElementProperties() {
		if(descriptor == null) { 
			return null;
		}
		SourceBean propertiesSB = (SourceBean)descriptor.getAttribute(PropertiesConstants.PROPERTIES);
		List propertiesList = propertiesSB.getAttributeAsList(PropertiesConstants.PROPERTY);
		ElementProperty[] properties = new ElementProperty[propertiesList.size()];
		for(int i=0; i<propertiesList.size(); i++) {
    		ElementProperty prop = new ElementProperty();
    		SourceBean propSB = (SourceBean)propertiesList.get(i);
    		String nameprop = (String)propSB.getAttribute(PropertiesConstants.NAME_PROPERTY);
    		String typeprop = (String)propSB.getAttribute(PropertiesConstants.CODE_TYPE_PROPERTY);
    		prop.setName(nameprop);
    		prop.setType(typeprop);
    		List valuesList = propSB.getAttributeAsList(PropertiesConstants.VALUE_PROPERTY_SB);
    		Vector values = new Vector();
    		for(int j=0; j<valuesList.size(); j++) {
    			SourceBean valueSB = (SourceBean)valuesList.get(j);
    			Object value = valueSB.getAttribute(PropertiesConstants.VALUE_PROPERTY);
    			values.add(value);
    		}
    		prop.setValues(values);
	        properties[i] = prop; 	
		}
		return properties;
	}
	
	
	public ElementProperty[] getNamedElementProperties(String name) {
		
		// if descriptor is null  
		if(descriptor == null) { 
			return null;
		}
		
		// if the properties is not present return null
		SourceBean propertiesSB = (SourceBean)descriptor.getAttribute(PropertiesConstants.PROPERTIES);
		List propertiesList = null;
		try{
			propertiesList = propertiesSB.getFilteredSourceBeanAttributeAsList(PropertiesConstants.PROPERTY, 
			                 PropertiesConstants.NAME_PROPERTY, name);
		} catch (Exception e) { return null; }
		
		// if no properties is found return null
		if(propertiesList.size()==0) {
			return null;
		}
		
		ElementProperty[] properties = new ElementProperty[propertiesList.size()];
		for(int i=0; i<propertiesList.size(); i++) {
    		ElementProperty prop = new ElementProperty();
    		SourceBean propSB = (SourceBean)propertiesList.get(i);
    		String nameprop = (String)propSB.getAttribute(PropertiesConstants.NAME_PROPERTY);
    		String typeprop = (String)propSB.getAttribute(PropertiesConstants.CODE_TYPE_PROPERTY);
    		prop.setName(nameprop);
    		prop.setType(typeprop);
    		List valuesList = propSB.getAttributeAsList(PropertiesConstants.VALUE_PROPERTY_SB);
    		Vector values = new Vector();
    		for(int j=0; j<valuesList.size(); j++) {
    			SourceBean valueSB = (SourceBean)valuesList.get(j);
    			Object value = valueSB.getAttribute(PropertiesConstants.VALUE_PROPERTY);
    			values.add(value);
    		}
    		prop.setValues(values);
	        properties[i] = prop; 	
		}
		return properties;
	}
	
	public InputStream getContent() {
		InputStream is = null;
		try {
			is = (InputStream)descriptor.getAttribute(OperationsConstants.STREAM);
		} catch (Exception e) {
			// ignore
		}
		return is;
	}
	
	public String getName() {
		String name = null;
		try {
			name = (String)descriptor.getAttribute(OperationsConstants.NAME);
		} catch (Exception e) {
			// ignore
		}
		return name;
	}
	
	public boolean hasChilds() {
		SourceBean childs = (SourceBean)descriptor.getAttribute(OperationsConstants.CHILDS);
		List childsList = childs.getContainedSourceBeanAttributes();
		if(childsList.size() > 0) {
			return true;
		} else {
			return false;
		}
	}
	
}
